Robotsystem of the Robot Group Leipzig: Arm2Segm Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages
- Examples

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Arm2Segm Class Reference

`#include <arm2segm.h>`

Inherits OdeRobot.

Inheritance diagram for Arm2Segm:

[legend]
Collaboration diagram for Arm2Segm:

[legend]
List of all members.

## Public Member Functions
| Arm2Segm (const OdeHandle &odeHandle, const OsgHandle &osgHandle, const Arm2SegmConf)
virtual | ~Arm2Segm ()
virtual void | update ()
| update the subcomponents
virtual void | place (const osg::Matrix &pose)
| sets the vehicle to position pos, sets color to c, and creates robot if necessary
virtual int | getSensors (sensor *sensors, int sensornumber)
| returns actual sensorvalues
virtual void | setMotors (const motor *motors, int motornumber)
| sets actual motorcommands
virtual int | getSensorNumber ()
| returns number of sensors
virtual int | getMotorNumber ()
| returns number of motors
virtual int | getSegmentsPosition (std::vector< Position > &poslist)
| returns a vector with the positions of all segments of the robot
virtual Primitive * | getMainPrimitive () const
| the main object of the robot, which is used for position and speed tracking
virtual bool | collisionCallback (void *data, dGeomID o1, dGeomID o2)
virtual void | doInternalStuff (GlobalData &globalData)
| this function is called in each timestep.
paramlist | getParamList () const
| The list of all parameters with there value as allocated lists.
virtual paramval | getParam (const paramkey &key) const
virtual bool | setParam (const paramkey &key, paramval val)
## Static Public Member Functions
static Arm2SegmConf | getDefaultConf ()
## Protected Member Functions
virtual void | create (const osg::Matrix &pose)
| creates vehicle at desired position
virtual void | destroy ()
| destroys vehicle and space
## Static Protected Member Functions
static void | mycallback (void *data, dGeomID o1, dGeomID o2)
## Protected Attributes
dSpaceID | parentspace
Arm2SegmConf | conf
std::vector< Primitive * > | objects
std::vector< Joint * > | joints
std::vector< AngularMotor1Axis * > | amotors
std::string | name
paramval | speed
paramval | factorSensors
int | sensorno
int | motorno
bool | created

## Constructor & Destructor Documentation

Arm2Segm | ( | const OdeHandle & | odeHandle,
|  | const OsgHandle & | osgHandle,
|  | const | Arm2SegmConf |
| ) |  |  |

virtual ~Arm2Segm | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

bool collisionCallback | ( | void * | data,
|  | dGeomID | o1,
|  | dGeomID | o2 |
| ) |  |  | `[virtual]`

Deprecated:
  Do not use it anymore, collision control is done automatically. In case of a treatment return true (collision will be ignored by other objects and the default routine) else false (collision is passed to other objects and (if not treated) to the default routine).

Reimplemented from OdeRobot.

void create | ( | const osg::Matrix & | pose | ) | `[protected, virtual]`

creates vehicle at desired position

Parameters:

  | pose | 4x4 pose matrix

pose

pose

pose

void destroy | ( |  | ) | `[protected, virtual]`

destroys vehicle and space

void doInternalStuff | ( | GlobalData & | globalData | ) | `[virtual]`

this function is called in each timestep.

It should perform robot-internal checks, like space-internal collision detection, sensor resets/update etc.

Parameters:

  | globalData | structure that contains global data from the simulation environment

Implements OdeRobot.

static Arm2SegmConf getDefaultConf | ( |  | ) | `[inline, static]`

Primitive * getMainPrimitive | ( |  | ) | const`[virtual]`

the main object of the robot, which is used for position and speed tracking

Implements OdeRobot.

virtual int getMotorNumber | ( |  | ) | `[inline, virtual]`

returns number of motors

Implements AbstractRobot.

Configurable::paramval getParam | ( | const paramkey & | key | ) | const`[virtual]`

Configurable::paramlist getParamList | ( |  | ) | const`[virtual]`

The list of all parameters with there value as allocated lists.

Returns:
  list of names

Reimplemented from Configurable.

int getSegmentsPosition | ( | std::vector< Position > & | poslist | ) | `[virtual]`

returns a vector with the positions of all segments of the robot

Parameters:

  | poslist | vector of positions (of all robot segments)

Returns:
  length of the list

virtual int getSensorNumber | ( |  | ) | `[inline, virtual]`

returns number of sensors

Implements AbstractRobot.

int getSensors | ( | sensor * | sensors,
|  | int | sensornumber |
| ) |  |  | `[virtual]`

returns actual sensorvalues

Parameters:

  | sensors | sensors scaled to [-1,1]
  | sensornumber | length of the sensor array

Returns:
  number of actually written sensors

Implements AbstractRobot.

void mycallback | ( | void * | data,
|  | dGeomID | o1,
|  | dGeomID | o2 |
| ) |  |  | `[static, protected]`

void place | ( | const osg::Matrix & | pose | ) | `[virtual]`

sets the vehicle to position pos, sets color to c, and creates robot if necessary

Parameters:

  | pose | desired 4x4 pose matrix

Implements OdeRobot.

void setMotors | ( | const motor * | motors,
|  | int | motornumber |
| ) |  |  | `[virtual]`

sets actual motorcommands

Parameters:

  | motors | motors scaled to [-1,1]
  | motornumber | length of the motor array

Implements AbstractRobot.

bool setParam | ( | const paramkey & | key,
|  | paramval | val |
| ) |  |  | `[virtual]`

void update | ( |  | ) | `[virtual]`

update the subcomponents

Implements OdeRobot.

## Member Data Documentation

std::vector<AngularMotor1Axis*> amotors`[protected]`

Arm2SegmConf conf`[protected]`

bool created`[protected]`

paramval factorSensors`[protected]`

std::vector<Joint*> joints`[protected]`

int motorno`[protected]`

std::string name`[protected]`

Reimplemented from Configurable.

std::vector<Primitive*> objects`[protected]`

dSpaceID parentspace`[protected]`

Reimplemented from OdeRobot.

int sensorno`[protected]`

paramval speed`[protected]`

The documentation for this class was generated from the following files:

- arm2segm.h
- arm2segm.cpp